//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft
// premium shared source license agreement under which you licensed
// this source code. If you did not accept the terms of the license
// agreement, you are not authorized to use this source code.
// For the terms of the license, please see the license agreement
// signed by you and Microsoft.
// THE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//

// Top-level objects
const GUID ASF_Header_Object		= { 0x75B22630,0x668E,0x11CF,{ 0xA6,0xD9,0x00,0xAA,0x00,0x62,0xCE,0x6C }};
const GUID ASF_Data_Object			= { 0x75B22636,0x668E,0x11CF,{ 0xA6,0xD9,0x00,0xAA,0x00,0x62,0xCE,0x6C }};
const GUID ASF_Simple_Index_Object	= { 0x33000890,0xE5B1,0x11CF,{ 0x89,0xF4,0x00,0xA0,0xC9,0x03,0x49,0xCB }};

// Header objects
const GUID ASF_File_Properties_Object				= { 0x8CABDCA1,0xA947,0x11CF,{ 0x8E,0xE4,0x00,0xC0,0x0C,0x20,0x53,0x65 }};
const GUID ASF_Stream_Properties_Object				= { 0xB7DC0791,0xA9B7,0x11CF,{ 0x8E,0xE6,0x00,0xC0,0x0C,0x20,0x53,0x65 }};
const GUID ASF_Stream_Bitrate_Properties_Object		= { 0x7BF875CE,0x468D,0x11D1,{ 0x8D,0x82,0x00,0x60,0x97,0xC9,0xA2,0xB2 }};
const GUID ASF_Content_Description_Object			= { 0x75B22633,0x668E,0x11CF,{ 0xA6,0xD9,0x00,0xAA,0x00,0x62,0xCE,0x6C }};
const GUID ASF_Extended_Content_Encryption_Object	= { 0x298AE614,0x2622,0x4c17,{ 0xB9,0x35,0xDA,0xE0,0x7E,0xE9,0x28,0x9C }};
const GUID ASF_Script_Command_Object				= { 0x1EFB1A30,0x0B62,0x11D0,{ 0xA3,0x9B,0x00,0xA0,0xC9,0x03,0x48,0xF6 }};
const GUID ASF_Marker_Object						= { 0xF487CD01,0xA951,0x11CF,{ 0x8E,0xE6,0x00,0xC0,0x0C,0x20,0x53,0x65 }};
const GUID ASF_Header_Extension_Object				= { 0x5FBF03B5,0xA92E,0x11CF,{ 0x8E,0xE3,0x00,0xC0,0x0C,0x20,0x53,0x65 }};
const GUID ASF_Bitrate_Mutual_Exclusion_Object		= { 0xD6E229DC,0x35DA,0x11D1,{ 0x90,0x34,0x00,0xA0,0xC9,0x03,0x49,0xBE }};
const GUID ASF_Codec_List_Object					= { 0x86D15240,0x311D,0x11D0,{ 0xA3,0xA4,0x00,0xA0,0xC9,0x03,0x48,0xF6 }};
const GUID ASF_Extended_Content_Description_Object	= { 0xD2D0A440,0xE307,0x11D2,{ 0x97,0xF0,0x00,0xA0,0xC9,0x5E,0xA8,0x50 }};
const GUID ASF_Error_Correction_Object				= { 0x75B22635,0x668E,0x11CF,{ 0xA6,0xD9,0x00,0xAA,0x00,0x62,0xCE,0x6C }};
const GUID ASF_Padding_Object						= { 0x1806D474,0xCADF,0x4509,{ 0xA4,0xBA,0x9A,0xAB,0xCB,0x96,0xAA,0xE8 }};

// HeaderExtension objects
const GUID ASF_Extended_Stream_Properties_Object    = { 0x14E6A5CB,0xC672,0x4332,{ 0x83,0x99,0xA9,0x69,0x52,0x06,0x5B,0x5A }};

// Object Stream type
const GUID ASF_Audio_Media		= { 0xF8699E40,0x5B4D,0x11CF,{ 0xA8,0xFD,0x00,0x80,0x5F,0x5C,0x44,0x2B }};
const GUID ASF_Video_Media		= { 0xBC19EFC0,0x5B4D,0x11CF,{ 0xA8,0xFD,0x00,0x80,0x5F,0x5C,0x44,0x2B }};
const GUID ASF_Command_Media	= { 0x59DACFC0,0x59E6,0x11D0,{ 0xA3,0xAC,0x00,0xA0,0xC9,0x03,0x48,0xF6 }};

// Error Correction type
const GUID ASF_No_Error_Correction		= { 0x20FB5700,0x5B55,0x11CF,{ 0xA8,0xFD,0x00,0x80,0x5F,0x5C,0x44,0x2B }};
const GUID ASF_Audio_Spread				= { 0xBFC3CD50,0x618F,0x11CF,{ 0x8B,0xB2,0x00,0xAA,0x00,0xB4,0xE2,0x20 }};

// mutual exclusion stuff
const GUID ASF_Mutex_Bitrate			= { 0xD6E22A01,0x35DA,0x11D1,{ 0x90,0x34,0x00,0xA0,0xC9,0x03,0x49,0xBE }};
const GUID ASF_Mutex_Unknown			= { 0xD6E22A02,0x35DA,0x11D1,{ 0x90,0x34,0x00,0xA0,0xC9,0x03,0x49,0xBE }};
const GUID ASF_Mutex_Language	        = { 0xD6E22A00,0x35DA,0x11D1,{ 0x90,0x34,0x00,0xA0,0xC9,0x03,0x49,0xBE }};

const GUID ASF_Reserved_1               = { 0xABD3D211,0xA9BA,0x11CF,{ 0x8E,0xE6,0x00,0xC0,0x0C,0x20,0x53,0x65 }};
const GUID ASF_Reserved_2	            = { 0x86D15241,0x311D,0x11D0,{ 0xA3,0xA4,0x00,0xA0,0xC9,0x03,0x48,0xF6 }};
const GUID ASF_Reserved_3	            = { 0x4B1ACBE3,0x100B,0x11D0,{ 0xA3,0x9B,0x00,0xA0,0xC9,0x03,0x48,0xF6 }};
const GUID ASF_Reserved_4	            = { 0x4CFEDB20,0x75F6,0x11CF,{ 0x9C,0x0F,0x00,0xA0,0xC9,0x03,0x49,0xCB }};

